#ifndef FUNCTIONS_RUNSCRIPT
#define FUNCTIONS_RUNSCRIPT

extern struct KernelBase *KernelBase;

static ERROR RunScript(STRING Location, OBJECTID OwnerID, OBJECTID *PrimaryID, STRING Array, ...)
{
   struct acSetUnlistedField set;
   OBJECTPTR script;
   STRING *args;
   FIELD fidPrimaryObject;

   args = &Array;

   if (NewObject(ID_SCRIPT, NULL, &script, NULL) IS ERR_Okay) {
      SetFields(script, FID_Location|TSTRING, Location,
                        FID_Owner|TLONG,      OwnerID,
                        TAGEND);

      while (*args) {
         set.Field = args[0];
         set.Value = args[1];
         if (Action(AC_SetUnlistedField, script, &set) != ERR_Okay) {
            Action(AC_Free, script, NULL);
            return(ERR_Failed);
         }
         args += 2;
      }

      if (Action(AC_Init, script, NULL) IS ERR_Okay) {
         if (Action(AC_Activate, script, NULL) IS ERR_Okay) {
            ResolveFields("PrimaryObject", &fidPrimaryObject, TAGEND);
            GetField(script, fidPrimaryObject, FT_LONG, PrimaryID);
            Action(AC_Free, script, NULL);
            return(ERR_Okay);
         }
         else { Action(AC_Free, script, NULL); return(ERR_Activate); }
      }
      else { Action(AC_Free, script, NULL); return(ERR_Init); }
   }
   else return(ERR_NewObject);
}

#endif /* FUNCTIONS_RUNSCRIPT */
